//+------------------------------------------------------------------+
//|                                                  MACD Mcarty.mq4 |
//|                                       Copyright  2007, Aaragorn |
//|                   http://www.forex-tsd.com/members/aaragorn.html |
//+------------------------------------------------------------------+
//------------------INCLUDES---------------//
#include <stdlib.mqh>

extern double                           risk = 1;// settings less than zero must have a zero to the right of the decimal like this example 0.15
extern double                        MaxLots = 10;
extern string Dynamic_Trailing_Stop_Settings = "Dynamic Trailing Stop Settings";
extern bool               EnableTrailingStop = true; // Enable Dynamic Trailing Stop
extern int                    TrailATRPeriod = 7;
extern double             TrailingStopFactor = 1.45;
// Dynamic Trailing stop (TS) global variables
double PrevBuyStop=0,BuyStop=0;
double PrevSellStop=0,SellStop=0,TrailingStop=0;

//internal global variables
int LongMagicNumber = 0;            // Order control number for the long orders placed                              
int ShortMagicNumber = 0;           // Order control number for the short orders placed  
double Lots = 0;
int init()
  {

// For those of us tired of messing around assigning annoying but essential magic numbers.
   
   if (Symbol()=="AUDCADm" || Symbol()=="AUDCAD") {LongMagicNumber=100001;ShortMagicNumber=200001;}
   if (Symbol()=="AUDJPYm" || Symbol()=="AUDJPY") {LongMagicNumber=100002;ShortMagicNumber=200002;}
   if (Symbol()=="AUDNZDm" || Symbol()=="AUDNZD") {LongMagicNumber=100003;ShortMagicNumber=200003;}
   if (Symbol()=="AUDUSDm" || Symbol()=="AUDUSD") {LongMagicNumber=100004;ShortMagicNumber=200004;}
   if (Symbol()=="CHFJPYm" || Symbol()=="CHFJPY") {LongMagicNumber=100005;ShortMagicNumber=200005;}
   if (Symbol()=="EURAUDm" || Symbol()=="EURAUD") {LongMagicNumber=100006;ShortMagicNumber=200006;}
   if (Symbol()=="EURCADm" || Symbol()=="EURCAD") {LongMagicNumber=100007;ShortMagicNumber=200007;}
   if (Symbol()=="EURCHFm" || Symbol()=="EURCHF") {LongMagicNumber=100008;ShortMagicNumber=200008;}
   if (Symbol()=="EURGBPm" || Symbol()=="EURGBP") {LongMagicNumber=100009;ShortMagicNumber=200009;}
   if (Symbol()=="EURJPYm" || Symbol()=="EURJPY") {LongMagicNumber=100010;ShortMagicNumber=200010;}
   if (Symbol()=="EURUSDm" || Symbol()=="EURUSD") {LongMagicNumber=100011;ShortMagicNumber=200011;}
   if (Symbol()=="GBPCHFm" || Symbol()=="GBPCHF") {LongMagicNumber=100012;ShortMagicNumber=200012;}   
   if (Symbol()=="GBPJPYm" || Symbol()=="GBPJPY") {LongMagicNumber=100013;ShortMagicNumber=200013;}
   if (Symbol()=="GBPUSDm" || Symbol()=="GBPUSD") {LongMagicNumber=100014;ShortMagicNumber=200014;}
   if (Symbol()=="NZDJPYm" || Symbol()=="NZDJPY") {LongMagicNumber=100015;ShortMagicNumber=200015;}
   if (Symbol()=="NZDUSDm" || Symbol()=="NZDUSD") {LongMagicNumber=100016;ShortMagicNumber=200016;}
   if (Symbol()=="USDCHFm" || Symbol()=="USDCHF") {LongMagicNumber=100017;ShortMagicNumber=200017;}
   if (Symbol()=="USDJPYm" || Symbol()=="USDJPY") {LongMagicNumber=100018;ShortMagicNumber=200018;}
   if (Symbol()=="USDCADm" || Symbol()=="USDCAD") {LongMagicNumber=100019;ShortMagicNumber=200019;}
   if (LongMagicNumber==0) {LongMagicNumber = 100999;}   
   if (ShortMagicNumber==0) {ShortMagicNumber = 200999;}   
   return(0);
   
  }//int init
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  Comment ("Order Control Numbers: Long = ",LongMagicNumber," Short = ",ShortMagicNumber);
   double MacdCurrent, MacdPrevious, SignalCurrent,SignalPrevious;
   int cnt, ticket, total;

// internal variables
   MacdCurrent=iMACD(NULL,0,6,12,2,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,6,12,2,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,0,6,12,2,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,6,12,2,PRICE_CLOSE,MODE_SIGNAL,1);

// call DTS
   DynamicTrailStop();

// Scale Lots   
   Lots = NormalizeDouble( (AccountFreeMargin() / 50.0) * (risk/100.0), 2);
   if ( Lots < 0.01 ) Lots = 0.01;
   if( Lots > MaxLots ) Lots = MaxLots;

// manage orders
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified

      // check for long position (BUY) possibility
        if(SignalPrevious<=MacdPrevious && SignalCurrent>MacdCurrent)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"mcarty",LongMagicNumber,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
        if(SignalPrevious>=MacdPrevious && SignalCurrent<MacdCurrent)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"mcarty",ShortMagicNumber,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }

// closing loop  
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY && OrderMagicNumber()==LongMagicNumber)   // long position is opened
           {
            // should it be closed?
            if(SignalPrevious>=MacdPrevious && SignalCurrent<MacdCurrent)   
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
           }
         else // go to short position
           {
            // should it be closed?
              if(SignalPrevious<=MacdPrevious && SignalCurrent>MacdCurrent && OrderMagicNumber()==ShortMagicNumber) 
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
           }
        }
     }
   return(0);
  }//ini start 
  
//+------------------------------------------------------------------+
//| Dynamic Trailing Stop                                            |
//+------------------------------------------------------------------+
// Check to see if "EnableTrailingStop" is enabled..if not no need to execute
// Only Modify the "StopLevel" here, since the exits are executed on the next function ExitMarket()
// please make sure that the distance is >= 5 pips from the market, otherwise the stop order modification will be rejected.
// Thank you!
int DynamicTrailStop()
{
    //Print("answer call trailstop");
    if(EnableTrailingStop)
      {

       TrailingStop = (TrailingStopFactor * iATR(Symbol(), 0 , TrailATRPeriod , 1) );
       for(int cnt = 0; cnt < OrdersTotal(); cnt++)
         {
            bool DynamicTrailAllowed = true;
            OrderSelect(cnt, SELECT_BY_POS);
            if(OrderType() == OP_BUY && OrderMagicNumber() != LongMagicNumber)//insures only mcarty placed orders are dynamic trail stop managed
               {
               DynamicTrailAllowed = False;
               } 
            if(OrderType() == OP_SELL && OrderMagicNumber() != ShortMagicNumber)//insures only mcarty placed orders are dynamic trail stop managed
               {
               DynamicTrailAllowed = False;
               }       
            if(DynamicTrailAllowed && OrderSymbol() == Symbol() && TrailingStop > 0)
               {
               if(OrderType() == OP_BUY && OrderMagicNumber() == LongMagicNumber)// If order is a long position
                  {
                  BuyStop = Bid - TrailingStop;
                  if(BuyStop < PrevBuyStop) // We maintain the highest value
                     {
                     BuyStop = PrevBuyStop;
                     }
                  if(BuyStop > 0 && (Bid - BuyStop) >= Bid - (5 * Point)  && BuyStop > OrderStopLoss())// if new stop loss is allowed and higher than current stop loss
                     {
                     OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0);
                     }
                  }
                  else 
                  {
                  if(OrderType() == OP_SELL && OrderMagicNumber() == ShortMagicNumber)// If order is a short position
                     {
                     SellStop = Ask + TrailingStop;
                     if(SellStop > PrevSellStop) // We maintain the lowest value
                        {
                        SellStop = PrevSellStop;
                        }
                     if(SellStop > 0 && (SellStop - Ask) >= Ask + (5 * Point)  && SellStop < OrderStopLoss())// if new stop loss is allowed and lower than current stop loss
                        {
                        OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0);
                        }
                     }//ifOT=S
                  }//ifOT=B
                           
                  if(OrderType() == OP_BUY && OrderMagicNumber() == LongMagicNumber)// If order is a long position
                  {
                     BuyStop = Bid - TrailingStop;
                     if(BuyStop < PrevBuyStop) BuyStop = PrevBuyStop;
                     if(BuyStop > 0 && (Bid - BuyStop) >= 5 * Point && BuyStop > OrderStopLoss())
                        {
                        OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0);
                        }
                  }
                  else 
                  {
                     if(OrderType() == OP_SELL && OrderMagicNumber() == ShortMagicNumber)// If order is a short position
                     {
                        SellStop = Ask + TrailingStop;
                        if(SellStop > PrevSellStop) SellStop = PrevSellStop;
                        if(SellStop > 0 && (SellStop - Ask) >= 5 * Point && SellStop < OrderStopLoss())
                           {
                           OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0);
                           }
                     }
                  }

              }//ifDTA
         PrevBuyStop = BuyStop;
         PrevSellStop = SellStop;
      }//for
   }//ifEnableTS      
return (0);
}//DTS 